/**
 * @package Blue Hat CDN
 * @version 1.3
 * @copyright (C) Copyright 2013 Blue Hat Network, BlueHatNetwork.com. All rights reserved.
 * @license GNU/GPL http://www.gnu.org/licenses/gpl-3.0.txt

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

var BHN = {
	startedScanningProcessTxt: null,
	startedSyncProcessTxt: null,
	finishedScanningSyncTxt: null,
	confirmClearIndexDataTxt: null,
	indexDataClearedSuccessTxt: null,
	anErrorOcurredtxt: null,
	alreadyRunningMsg: null,
	stopScanMonitor: false,
	busy: false,
	serverUri: null,
	excludeFilePathPatternList: '',
	timer: null,
	recordsPerPage: 30,
	loadedInitialSet: false,
	isEnabled: 0,
	pluginBasePath: null,
	
	changeCDNProviderDropDown: function (newProvider) {
		if (!newProvider || newProvider == '') {
			jQuery('#get_api_credentials_link').css('display', 'none');
		} else {
			jQuery('#get_api_credentials_link').css('display', 'inline-block');
			
			if (newProvider == 'bhn') {
				jQuery('#get_api_credentials_link').attr('href', 'https://www.bluehatnetwork.com/my-account/cdn-buckets.html');
			} else if (newProvider == 'maxcdn') {
				jQuery('#get_api_credentials_link').attr('href', 'http://tracking.maxcdn.com/c/77101/3961/378');
			} else if (newProvider == 'aws') {
				jQuery('#get_api_credentials_link').attr('href', 'http://aws.amazon.com/cloudfront/?_encoding=UTF8&camp=1789&creative=9325&linkCode=ur2&tag=bluhatnet-20');
			} else if (newProvider == 'rackspace_cloudfiles') {
				jQuery('#get_api_credentials_link').attr('href', 'http://tracking.rackspace.com/SHDA');
			} else if (newProvider == 'rackspace_cloudfiles_uk') {
				jQuery('#get_api_credentials_link').attr('href', 'http://tracking.rackspace.com/SHDA');
			}
		}
	},
	
	addFilePathPatternToExcludeList: function (pattern) {
		BHN.excludeFilePathPatternList = pattern+','+BHN.excludeFilePathPatternList;
		BHN.refreshExcludeFileGrid();
		jQuery('#add_file_pattern_to_exclude').val('');
	},
	
	deleteFilePathPatternFromExcludeList: function (pattern) {
		var excludedFilesData = BHN.excludeFilePathPatternList.split(",");
		var newValue = '';

		for(var i = 0; i < excludedFilesData.length; i++)
		{
			if (excludedFilesData[i] != pattern) {
				newValue += excludedFilesData[i]+',';
			}
		}
		
		newValue = newValue.replace(/,$/, '');
		
		BHN.excludeFilePathPatternList = newValue;
		
		BHN.refreshExcludeFileGrid();
	},
	
	refreshExcludeFileGrid: function () {
		jQuery("#exclude_files").jqGrid("clearGridData", true);
		
		jQuery('#exclude_file_list').val(BHN.excludeFilePathPatternList);
		
		var excludedFilesData = BHN.excludeFilePathPatternList.split(",");
		var excludedFilesDataFinal = [];

		for(var i = 0; i < excludedFilesData.length; i++)
		{
			excludedFilesDataFinal.push({name: excludedFilesData[i]+' <a style="float: right; margin-right: 3px;" href="javascript: void(0);" onclick="BHN.deleteFilePathPatternFromExcludeList(\''+excludedFilesData[i]+'\');"><img src="'+BHN.pluginBasePath+'assets/images/icons/x.png" width="12" height="12" border="0" alt="" align="absmiddle" /></a>'});
		}

		for(var i = 0 ;i <= excludedFilesDataFinal.length; i++)
		{
			jQuery("#exclude_files").jqGrid('addRowData', i+1, excludedFilesDataFinal[i]);
		}
	},
	
	showSettingsTab: function () {
		jQuery("#tabs").tabs("option", "active", jQuery('#tabs a[href="#tabs-2"]').parent().index());
	},
	
	startScanSync: function () {
		if (BHN.isEnabled < 1) {
			alert(BHN.anErrorOcurredtxt);
		} else if (!BHN.busy) {
			BHN.busy = true;
			
			if (String(jQuery('#clear_button_container').css('display')).indexOf('none') > -1) {
				jQuery('#clear_button_container').css('display', 'block');
			}
			
			jQuery.jGrowl(BHN.startedScanningProcessTxt+'<br /><br /><div id="status_msg">&nbsp;</div><div id="sync_status_msg"></div>', { sticky: true });

			BHN.startScan();
			
			setTimeout('BHN.monitorScanSyncStatus();', 4000);
		} else {
			alert(BHN.alreadyRunningMsg);
		}
	},
	
	monitorScanSyncStatus: function () {
		jQuery.post(BHN.serverUri+'?action=bhn_get_scan_sync_status', function (data) {
			if(data) {
				if (BHN.busy) {
					if (String(jQuery('#file_stats').html()).replace(/[^0-9a-zA-Z]+/g, "") != String(data.file_stats).replace(/[^0-9a-zA-Z]+/g, "")) {
						jQuery("#file_stats").html(data.file_stats);
						jQuery("#file_stats").fadeOut(100).fadeIn(100);
					}
					
					if (data.process_mode == 'scan') {
						jQuery('#status_msg').html(data.status_msg);
					} else if(data.process_mode == 'sync') {
						if(!BHN.loadedInitialSet && data.status_msg) {
							BHN.loadedInitialSet = true;
							setTimeout('jQuery("#files_grid").trigger("reloadGrid", [{page:1}]);', 1000);
						}
						
						jQuery('#sync_status_msg').html('<br />'+data.status_msg);
					} else if(data.process_mode == 'completed') {
						BHN.scanSyncCompleted();
					}
				}
			}
		}, "json").always(function () {
			if (BHN.busy && !BHN.stopScanMonitor) {
				BHN.timer = setTimeout('BHN.monitorScanSyncStatus();', 1400);
			}
		});
	},
	
	startScan: function () {		
		jQuery.ajax({
			type: "POST",
			url: BHN.serverUri,
			dataType: "json",
			timeout: 0,
			cache: false,
			success: function (data) {
				BHN.scanSyncCompleted();
			},
			data: {
				action: 'bhn_scan_sync_files',
				param1: ''
			}
		});
	},
	
	scanSyncCompleted: function () {
		BHN.busy = false;
		
		if (BHN.timer) {
			clearTimeout(BHN.timer);
			BHN.stopScanMonitor = true;
			BHN.timer = null;
		}
		
		jQuery.jGrowl(BHN.finishedScanningSyncTxt, { sticky: true });
	   
		var alertFunc = function () {
			alert(BHN.finishedScanningSyncTxt);
			
			location.reload(true);
		};
		
		setTimeout(alertFunc, 2000);
	},
	
	clearIndexData: function () {
		var answer = confirm(BHN.confirmClearIndexDataTxt);
		
		if (answer) {
			alert(BHN.indexDataClearedSuccessTxt);
			
			document.location.href=BHN.serverUri+'?action=bhn_clear_index_data';
		}
	}
};