<?php
/**
 * @package Blue Hat CDN
 * @version 1.3
 * @copyright (C) Copyright 2013 Blue Hat Network, BlueHatNetwork.com. All rights reserved.
 * @license GNU/GPL http://www.gnu.org/licenses/gpl-3.0.txt

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class BlueHatNetworkCommon
{
	function isValidEmailAddress($emailAddress)
	{
		if(!class_exists('BlueHatNetworkFactory')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'factory.php';
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			jimport('joomla.mail.helper');
			
			return JMailHelper::isEmailAddress($emailAddress);
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			return is_email($emailAddress);
		}
	}
	
	function getWebsiteOwnerEmailAddress()
	{
		if(!class_exists('BlueHatNetworkFactory')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'factory.php';
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			$config =& JFactory::getConfig();
			
			return $config->getValue('config.mailfrom');
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			return get_bloginfo('admin_email');
		}
	}
	
	function mkdir($dirPath)
	{
		if(!class_exists('BlueHatNetworkFactory')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'factory.php';
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			jimport('joomla.filesystem.folder');
			
			return JFolder::create($dirPath);
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			return wp_mkdir_p($dirPath);
		}
	}
	
	function humanReadableFilesize($size) 
	{
		$mod = 1024;
		
		$units = explode(' ', 'Bytes KB MB GB TB PB');

		for ($i = 0; $size > $mod; $i++) 
		{
			$size /= $mod;
		}

		return round($size, 2).' '.$units[$i];
	}
}