<?php
/**
 * @package Blue Hat CDN
 * @version 1.3
 * @copyright (C) Copyright 2013 Blue Hat Network, BlueHatNetwork.com. All rights reserved.
 * @license GNU/GPL http://www.gnu.org/licenses/gpl-3.0.txt

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class BlueHatNetworkDatabase
{
	function quote($str)
	{
		if(!class_exists('BlueHatNetworkFactory')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'factory.php';
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			$db =& JFactory::getDBO();
			
			return $db->Quote($str);
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			return '\''.esc_sql($str).'\'';
		}
	}
	
	function escape($str)
	{
		if(!class_exists('BlueHatNetworkFactory')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'factory.php';
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			$db =& JFactory::getDBO();
			
			return $db->getEscaped($str);
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			return esc_sql($str);
		}
	}
	
	function getTablePrefix()
	{
		if(!class_exists('BlueHatNetworkFactory')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'factory.php';
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			return '#_';
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			global $wpdb;
			
			return $wpdb->prefix;
		}
	}
	
	function getRow($sql)
	{
		if(!class_exists('BlueHatNetworkFactory')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'factory.php';
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			$db =& JFactory::getDBO();
			
			$db->setQuery($sql);
			
			return $db->loadAssoc();
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			global $wpdb;
			
			return $wpdb->get_row($sql, ARRAY_A);
		}
	}
	
	function getResults($sql)
	{
		if(!class_exists('BlueHatNetworkFactory')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'factory.php';
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			$db =& JFactory::getDBO();
			
			$db->setQuery($sql);
			
			return $db->loadAssocList();
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			global $wpdb;
			
			return $wpdb->get_results($sql, ARRAY_A);
		}
	}
	
	function getResult($sql)
	{
		if(!class_exists('BlueHatNetworkFactory')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'factory.php';
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			$db =& JFactory::getDBO();
			
			$db->setQuery($sql);
			
			return $db->loadResult();
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			global $wpdb;
			
			return $wpdb->get_var($sql);
		}
	}
	
	function insertData($tableName, $dataObj)
	{
		if(!class_exists('BlueHatNetworkFactory')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'factory.php';
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			$db =& JFactory::getDBO();
			
			return $db->insertObject($tableName, $dataObj);
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			global $wpdb;
			
			return $wpdb->insert($tableName, (array)$dataObj);
		}
	}
	
	function getLastInsertId()
	{
		if(!class_exists('BlueHatNetworkFactory')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'factory.php';
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			$db =& JFactory::getDBO();
			
			return $db->insertid();
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			global $wpdb;
			
			return $wpdb->insert_id;
		}
	}
	
	function query($sql)
	{
		if(!class_exists('BlueHatNetworkFactory')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'factory.php';
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			$db =& JFactory::getDBO();
			
			$db->setQuery($sql);
			
			return $db->query();
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			global $wpdb;
			
			return $wpdb->query($sql);
		}
	}
}