<?php
/**
 * @package Blue Hat CDN
 * @version 1.3
 * @copyright (C) Copyright 2013 Blue Hat Network, BlueHatNetwork.com. All rights reserved.
 * @license GNU/GPL http://www.gnu.org/licenses/gpl-3.0.txt

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class BlueHatNetworkFactory
{
	function isJoomla()
	{
		return (class_exists('JConfig')) ? true : false;
	}
	
	function isWordPress()
	{
		return (class_exists('WP')) ? true : false;
	}
	
	function getImgPath($URLFriendly=false)
	{
		$directorySeperator = ($URLFriendly) ? '/' : DIRECTORY_SEPARATOR;
		
		if(BlueHatNetworkFactory::isJoomla())
		{
			$imgPath = ($URLFriendly) ? JURI::root(true) : JPATH_SITE;
		}
		elseif(BlueHatNetworkFactory::isWordPress())
		{
			$imgPath = ($URLFriendly) ? preg_replace('@^https?://[^/]+@i', '', bloginfo('url')) : ABSPATH;
		}
		
		$imgPath .= $directorySeperator.'images'.$directorySeperator.'slc';
		
		return rtrim($imgPath, $directorySeperator);
	}
}