<?php
/**
 * @package Blue Hat CDN
 * @version 1.3
 * @copyright (C) Copyright 2013 Blue Hat Network, BlueHatNetwork.com. All rights reserved.
 * @license GNU/GPL http://www.gnu.org/licenses/gpl-3.0.txt

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class BlueHatNetworkNetwork
{
	static $_ch = null;
	
	function _do($url, $params=null, $keepConnectionOpen=false)
	{
		//open connection
		if(empty(self::$_ch)) self::$_ch = curl_init();
		
		//set the url, number of POST vars, POST data
		curl_setopt(self::$_ch, CURLOPT_URL, $url);
		curl_setopt(self::$_ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt(self::$_ch, CURLOPT_HTTPHEADER, array('Connection: Keep-Alive', 'Keep-Alive: 300', 'Expect:'));
		curl_setopt(self::$_ch, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt(self::$_ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt(self::$_ch, CURLOPT_ENCODING , 'gzip');

		if(!empty($params))
		{
			// This is a post
			curl_setopt(self::$_ch, CURLOPT_POST, true);
			curl_setopt(self::$_ch, CURLOPT_POSTFIELDS, $params);
		}

		//execute post
		$result = curl_exec(self::$_ch);

		//close connection
		if(!$keepConnectionOpen) self::closeConnection();
		
		return $result;
	}
	
	static function get($url)
	{
		return self::_do($url);
	}
	
	static function post($url, $params, $keepConnectionOpen=false)
	{
		return self::_do($url, $params, $keepConnectionOpen);
	}
	
	static function closeConnection()
	{
		if(!empty(self::$_ch)) 
		{
			curl_close(self::$_ch);
			
			self::$_ch = null;
		}
	}
}