<?php
/**
 * @package Blue Hat CDN
 * @version 1.3
 * @copyright (C) Copyright 2013 Blue Hat Network, BlueHatNetwork.com. All rights reserved.
 * @license GNU/GPL http://www.gnu.org/licenses/gpl-3.0.txt

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

if(!class_exists('BlueHatNetworkSetting')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'lib'.DIRECTORY_SEPARATOR.'setting.php';
if(!class_exists('BlueHatNetworkDateTime')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'lib'.DIRECTORY_SEPARATOR.'datetime.php';
if(!class_exists('BlueHatCDNModelBlueHatCDN')) require dirname(__FILE__).DIRECTORY_SEPARATOR.'models'.DIRECTORY_SEPARATOR.'bluehatcdn.php';

$bhnObj = new BlueHatCDNModelBlueHatCDN();
$settingObj = new BlueHatNetworkSetting();

if(!current_user_can('manage_options')) $settingObj->set('display_admin_message', '<span style="color: red; font-size: 1.2em;">Error: Access denied for current user to this plugin.</span>');

if($settingObj->get('display_admin_message'))
{
	echo '<br /><div class="updated">'.$settingObj->get('display_admin_message').'</div>';
	
	$settingObj->set('display_admin_message', null);
}
?>
<h1 style="color: #0B55C4;"><img src="<?php echo plugins_url('/assets/images/icons/', __FILE__); ?>bluehatcdn-icon-48.png" width="48" height="48" border="0" alt="" align="absmiddle" /> Blue Hat CDN</h1>
<form action="<?php echo admin_url('admin-ajax.php'); ?>" method="post" name="adminForm">
	<div id="tabs">
		<ul>
			<li><a href="#tabs-1"><?php echo __('BHN_CONTROL_PANEL', 'blue-hat-cdn'); ?></a></li>
			<li><a href="#tabs-2"><?php echo __('BHN_SETTINGS', 'blue-hat-cdn'); ?></a></li>
		</ul>
		<div id="tabs-1">
			<p>
				<button id="scan_sync_button" type="button" onclick="javascript: BHN.startScanSync();"><?php echo __('BHN_SCAN_SYNC_BUTTON', 'blue-hat-cdn'); ?></button>
				<br />
				<span style="font-size: 0.855em;"><?php echo __('BHN_SCAN_SYNC_BUTTON_NOTE', 'blue-hat-cdn'); ?></span>
				<br /><br /><br />
				<div id="file_stats" style="color: #464646;"><?php echo $bhnObj->getFileStats(true); ?></div>
				<br /><br />
				<table id="files_grid"><tr><td></td></tr></table>
				<div id="file_grid_pager"></div>
				<div id="clear_button_container" <?php if($bhnObj->getNumOfFiles() < 1) { ?>style="display: none;"<?php } ?>>
					<br /><br /><br /><br /><br /><br /><br />
					<button id="clear_data_button" type="button" onclick="javascript: BHN.clearIndexData();"><?php echo __('BHN_CLEAR_DATA_BUTTON', 'blue-hat-cdn'); ?></button>
				</div>
			</p>
		</div>
		<div id="tabs-2">
			<p>
				<table cellspacing="0" cellpadding="2" border="0" class="bhnAdminForm">
					<tr>
						<td class="bhnLabelCell"><label for="cdn_provider"><?php echo __('BHN_CDN_PROVIDER', 'blue-hat-cdn'); ?>:</label></td>
						<td>
							<select id="cdn_provider" name="cdn_provider" onchange="BHN.changeCDNProviderDropDown(this.value);">
								<option value=""><?php echo __('BHN_SELECT_CDN', 'blue-hat-cdn'); ?></option>
								<option value="bhn"<?php if($settingObj->get('cdn_provider') == 'bhn') { ?> selected="selected"<?php } ?>>Blue Hat Network</option>
								<option value="aws"<?php if($settingObj->get('cdn_provider') == 'aws') { ?> selected="selected"<?php } ?>>Amazon Cloudfront</option>
								<option value="rackspace_cloudfiles"<?php if($settingObj->get('cdn_provider') == 'rackspace_cloudfiles') { ?> selected="selected"<?php } ?>>Rackspace Cloudfiles</option>
								<option value="rackspace_cloudfiles_uk"<?php if($settingObj->get('cdn_provider') == 'rackspace_cloudfiles_uk') { ?> selected="selected"<?php } ?>>Rackspace Cloudfiles UK</option>
							</select>&nbsp;&nbsp;<a href="#" target="_blank" id="get_api_credentials_link"<?php if(!$settingObj->get('cdn_provider')) { ?> style="display: none;"<?php } ?>><?php echo __('BHN_GET_API_CREDENTIALS', 'blue-hat-cdn'); ?></a>
							<img height="1" width="1" src="//tracking.maxcdn.com/i/77101/3961/378" border="0" />
							<img src="//tracking.rackspace.com/aff_i?offer_id=2&aff_id=1300" width="1" height="1" border="0" />
							<img src="//ir-na.amazon-adsystem.com/e/ir?t=bluhatnet-20&l=ur2&o=1" width="1" height="1" border="0" alt="" style="border:none !important; margin:0px !important;" />
						</td>
					</tr>
					<tr>
						<td class="bhnLabelCell"><label for="cdn_username"><?php echo __('BHN_CDN_USERNAME', 'blue-hat-cdn'); ?>:</label></td>
						<td><input type="text" size="60" name="cdn_username" value="<?php echo $settingObj->get('cdn_username', ''); ?>" /></td>
					</tr>
					<tr>
						<td class="bhnLabelCell"><label for="cdn_api_key"><?php echo __('BHN_CDN_API_KEY', 'blue-hat-cdn'); ?>:</label></td>
						<td><input type="password" size="60" name="cdn_api_key" value="<?php echo $settingObj->get('cdn_api_key', ''); ?>" /></td>
					</tr>
				</table>
				<br />
				<table cellspacing="0" cellpadding="2" border="0" style="margin-left: 95px;">
					<tr>
						<td><input type="checkbox" id="offload_on_fly" name="offload_on_fly" value="1"<?php if ((int)$settingObj->get('offload_on_fly', 1) > 0) { ?> checked="checked"<?php } ?> /></td>
						<td class="bhnLabelCell"><label for="offload_on_fly"><?php echo __('BHN_OFFLOAD_ON_THE_FLY', 'blue-hat-cdn'); ?></label> <a href="javascript: void(0);" title="<?php echo __('BHN_OFFLOAD_ON_THE_FLY_TOOLTIP', 'blue-hat-cdn'); ?>">?</a></td>
					</tr>
					<tr>
						<td><input type="checkbox" id="prefetch_dns" name="prefetch_dns" value="1"<?php if ((int)$settingObj->get('prefetch_dns', 1) > 0) { ?> checked="checked"<?php } ?> /></td>
						<td class="bhnLabelCell"><label for="prefetch_dns"><?php echo __('BHN_PREFETCH_DNS', 'blue-hat-cdn'); ?></label> <a href="javascript: void(0);" title="<?php echo __('BHN_PREFETCH_DNS_TOOLTIP', 'blue-hat-cdn'); ?>">?</a></td>
					</tr>
					<tr>
						<td><input type="checkbox" id="optimize_html" name="optimize_html" value="1"<?php if ((int)$settingObj->get('optimize_html', 1) > 0) { ?> checked="checked"<?php } ?> /></td>
						<td class="bhnLabelCell"><label for="optimize_html"><?php echo __('BHN_OPTIMIZE_HTML', 'blue-hat-cdn'); ?></label> <a href="javascript: void(0);" title="<?php echo __('BHN_OPTIMIZE_HTML_TOOLTIP', 'blue-hat-cdn'); ?>">?</a></td>
					</tr>
					<tr>
						<td><input type="checkbox" id="include_js" name="include_js" value="1"<?php if ((int)$settingObj->get('include_js', 1) > 0) { ?> checked="checked"<?php } ?> /></td>
						<td class="bhnLabelCell"><label for="include_js"><?php echo __('BHN_INCLUDE_JS', 'blue-hat-cdn'); ?></label> <a href="javascript: void(0);" title="<?php echo __('BHN_INCLUDE_JS_TOOLTIP', 'blue-hat-cdn'); ?>">?</a></td>
					</tr>
					<tr>
						<td><input type="checkbox" id="include_css" name="include_css" value="1"<?php if ((int)$settingObj->get('include_css', 1) > 0) { ?> checked="checked"<?php } ?> /></td>
						<td class="bhnLabelCell"><label for="include_css"><?php echo __('BHN_INCLUDE_CSS', 'blue-hat-cdn'); ?></label> <a href="javascript: void(0);" title="<?php echo __('BHN_INCLUDE_CSS_TOOLTIP', 'blue-hat-cdn'); ?>">?</a></td>
					</tr>
					<tr>
						<td><input type="checkbox" id="include_images" name="include_images" value="1"<?php if ((int)$settingObj->get('include_images', 1) > 0) { ?> checked="checked"<?php } ?> /></td>
						<td class="bhnLabelCell"><label for="include_images"><?php echo __('BHN_INCLUDE_IMAGES', 'blue-hat-cdn'); ?></label> <a href="javascript: void(0);" title="<?php echo __('BHN_INCLUDE_IMAGES_TOOLTIP', 'blue-hat-cdn'); ?>">?</a></td>
					</tr>
					<tr>
						<td><input type="checkbox" id="include_font" name="include_font" value="1"<?php if ((int)$settingObj->get('include_font', 1) > 0) { ?> checked="checked"<?php } ?> /></td>
						<td class="bhnLabelCell"><label for="include_font"><?php echo __('BHN_INCLUDE_FONTS', 'blue-hat-cdn'); ?></label> <a href="javascript: void(0);" title="<?php echo __('BHN_INCLUDE_FONTS_TOOLTIP', 'blue-hat-cdn'); ?>">?</a></td>
					</tr>
					<!--
					<tr>
						<td><input type="checkbox" id="include_swf" name="include_swf" value="1"<?php if ((int)$settingObj->get('include_swf', 1) > 0) { ?> checked="checked"<?php } ?> /></td>
						<td class="bhnLabelCell"><label for="include_swf"><?php echo __('BHN_INCLUDE_SWF', 'blue-hat-cdn'); ?></label> <a href="javascript: void(0);" title="<?php echo __('BHN_INCLUDE_SWF_TOOLTIP', 'blue-hat-cdn'); ?>">?</a></td>
					</tr>
					-->
				</table>
				<br />
				<div style="margin-left: 95px;">
					<table id="exclude_files"></table>
					<label for="add_file_pattern_to_exclude" style="font-size: 0.9em;"><?php echo __('BHN_FILE_PATH_PATTERN_TO_ADD_EXCLUDE', 'blue-hat-cdn'); ?>:</label><input type="text" id="add_file_pattern_to_exclude" name="add_file_pattern_to_exclude" value="" style="margin-top: 5px;" /><button id="add_file_exclude_button" type="button" onclick="javascript: BHN.addFilePathPatternToExcludeList(jQuery('#add_file_pattern_to_exclude').val());"><?php echo __('BHN_FILE_PATH_PATTERN_TO_ADD_EXCLUDE_BTN', 'blue-hat-cdn'); ?></button>
				</div>
				<br />
				
				<table cellspacing="0" cellpadding="2" border="0" class="bhnAdminFormLight">
					<tr>
						<td class="bhnLabelCell" valign="top" style="padding-top: 5px;"><label for="optimize_database"><?php echo __('BHN_OPTIMIZE_DATABASE_TABLES', 'blue-hat-cdn'); ?>:</label></td>
						<td>
							<?php 
							$optimizeDatabase = $settingObj->get('optimize_database', 'daily');
							?>
							<select name="optimize_database">
								<option value=""<?php if(empty($optimizeDatabase)) { ?> selected="selected"<?php } ?>><?php echo __('BHN_NEVER', 'blue-hat-cdn'); ?></option>
								<option value="daily"<?php if($optimizeDatabase == 'daily') { ?> selected="selected"<?php } ?>><?php echo __('BHN_DAILY', 'blue-hat-cdn'); ?></option>
								<option value="weekly"<?php if($optimizeDatabase == 'weekly') { ?> selected="selected"<?php } ?>><?php echo __('BHN_WEEKLY', 'blue-hat-cdn'); ?></option>
								<option value="monthly"<?php if($optimizeDatabase == 'monthly') { ?> selected="selected"<?php } ?>><?php echo __('BHN_MONTHLY', 'blue-hat-cdn'); ?></option>
							</select> <a href="javascript: void(0);" title="<?php echo __('BHN_OPTIMIZE_DATABASE_TABLES_TOOLTIP', 'blue-hat-cdn'); ?>">?</a><br />
							<span style="font-size: 0.9em; color: grey;"><?php 
							$lastDbOptimizationDate = $settingObj->get('database_optimization_date', __('BHN_NEVER', 'blue-hat-cdn'));
							
							if(preg_match('@^[0-9]+$@', $lastDbOptimizationDate)) $lastDbOptimizationDate = date('F j, Y, g:i a', BlueHatNetworkDateTime::convertGMTUnixTimeStampToLocal($lastDbOptimizationDate));
							
							echo sprintf(__('BHN_DB_LAST_OPTIMIZED', 'blue-hat-cdn'), $lastDbOptimizationDate); 
							?></span><br /><br />
						</td>
					</tr>
					<tr>
						<td class="bhnLabelCell" valign="top" style="padding-top: 5px;"><label for="auto_scan_sync_interval"><?php echo __('BHN_AUTO_SCAN_SYNC', 'blue-hat-cdn'); ?>:</label></td>
						<td>
							<input type="text" name="auto_scan_sync_interval" value="<?php echo $settingObj->get('auto_scan_sync_interval', 0); ?>" size="10" /><?php echo __('BHN_SECONDS', 'blue-hat-cdn'); ?> <a href="javascript: void(0);" title="<?php echo __('BHN_AUTO_SCAN_SYNC_TOOLTIP', 'blue-hat-cdn'); ?>">?</a><br />
							<span style="font-size: 0.9em; color: grey;"><?php 
							$lastSyncDate = $settingObj->get('process_id', __('BHN_NEVER', 'blue-hat-cdn'));
							
							if(preg_match('@^[0-9]+$@', $lastSyncDate)) $lastSyncDate = date('F j, Y, g:i a', BlueHatNetworkDateTime::convertGMTUnixTimeStampToLocal($lastSyncDate));
							
							echo sprintf(__('BHN_LAST_SYNC_DATE', 'blue-hat-cdn'), $lastSyncDate);
							?></span>
						</td>
					</tr>
				</table>
				<br />
				<input type="hidden" id="exclude_file_list" name="exclude_file_list" value="<?php echo $settingObj->get('exclude_files', 'tmp/,logs/,cache/'); ?>" />
				<input type="hidden" name="action" value="bhn_save_settings" />
				<button type="submit" id="settings_form_save_btn"><?php echo __('BHN_SAVE', 'blue-hat-cdn'); ?></button>
			</p>
		</div>
	</div>
</form>
<script>
jQuery(document).ready(function() {
	BHN.serverUri = ajaxurl;
	BHN.pluginBasePath = '<?php echo plugins_url('/', __FILE__); ?>';
	BHN.isEnabled = <?php echo (int)blueHatCDNCheckRequirements(); ?>;
	
	<?php if($bhnObj->getNumOfFiles() > 0) { ?>
			BHN.loadedInitialSet = true;
	<?php } ?>
	
	BHN.startedScanningProcessTxt = '<?php echo str_replace('\'', '\\\'', __('BHN_STARTED_SCANNING_PROCESS_MSG', 'blue-hat-cdn')); ?>';
	BHN.startedSyncProcessTxt = '<?php echo str_replace('\'', '\\\'', __('BHN_STARTED_SYNC_PROCESS_MSG', 'blue-hat-cdn')); ?>';
	BHN.anErrorOcurredtxt = '<?php echo str_replace('\'', '\\\'', __('BHN_AN_ERROR_OCCURRED', 'blue-hat-cdn')); ?>';
	BHN.alreadyRunningMsg = '<?php echo str_replace('\'', '\\\'', __('BHN_BUSY_SCANNING', 'blue-hat-cdn')); ?>';
	BHN.finishedScanningSyncTxt = '<?php echo str_replace('\'', '\\\'', __('BHN_FINISHED_SCANNING', 'blue-hat-cdn')); ?>';
	BHN.confirmClearIndexDataTxt = '<?php echo str_replace('\'', '\\\'', __('BHN_CLEAR_INDEX_DATA_CONFIRM', 'blue-hat-cdn')); ?>';
	BHN.indexDataClearedSuccessTxt = '<?php echo str_replace('\'', '\\\'', __('BHN_INDEX_DATA_CLEARED_SUCCESSFULLY', 'blue-hat-cdn')); ?>';
	
	jQuery(document).tooltip();
	jQuery("#tabs").tabs();
	
	if (window.location.hash) {
		if (window.location.hash == '#settings') {
			BHN.showSettingsTab();
			window.location.hash = '';
		}
	}
	
	jQuery("#scan_sync_button").button();
	jQuery("#clear_data_button").button();
	jQuery("#settings_form_save_btn").button();
	jQuery("#add_file_exclude_button").button();
	
	jQuery('#add_file_pattern_to_exclude').bind('keypress', function (e) {
		if(e.keyCode == 13) {
			e.stopPropagation();
			
			BHN.addFilePathPatternToExcludeList(jQuery('#add_file_pattern_to_exclude').val());
			
			return false;
		}
	});
	
	BHN.changeCDNProviderDropDown(document.getElementById('cdn_provider').value);
	
	jQuery("#files_grid").jqGrid({
		url: BHN.serverUri,
		postData: {
			action: 'bhn_get_files'
		},
		rowNum: BHN.recordsPerPage,
		altRows: false,
		ignoreCase: true,
		pager: '#file_grid_pager',
		mtype: 'POST',
		datatype: 'json',
		height: 'auto',
		autoencode: false,
		viewrecords: true,
		autowidth: false,
		sortname: 'file_mdate',
		sortorder: 'desc',
		emptyrecords: '<?php echo str_replace('\'', '\\\'', __('BHN_NO_FILES_SCANNED', 'blue-hat-cdn')); ?>',
		colNames:[
			'<?php echo str_replace('\'', '\\\'', __('BHN_FILENAME_PATH', 'blue-hat-cdn')); ?>', 
			'<?php echo str_replace('\'', '\\\'', __('BHN_FILETYPE', 'blue-hat-cdn')); ?>', 
			'<?php echo str_replace('\'', '\\\'', __('BHN_ORIGINAL_FILESIZE', 'blue-hat-cdn')); ?>',
			'<?php echo str_replace('\'', '\\\'', __('BHN_FINAL_FILESIZE', 'blue-hat-cdn')); ?>',
			'<?php echo str_replace('\'', '\\\'', __('BHN_SYNCED_HEADER', 'blue-hat-cdn')); ?>'
		],
		cmTemplate: { title: false },
		colModel:[
			{name:'file_full_path', index:'file_full_path', width:550, sortable:true},
			{name:'file_extension', index:'file_extension', sortable:true, align:'center', width: 100},
			{name:'file_original_filesize', index:'file_original_filesize', sortable:true, align:'center', search: false},
			{name:'file_final_filesize', index:'file_final_filesize', sortable:true, align:'center', search: false},
			{name:'file_mdate', index:'file_mdate', sortable:true, align:'center', search: false}
		],
		caption: "<?php echo __('BHN_FILES_GRID_HEADING', 'blue-hat-cdn'); ?>"
	});
	
	jQuery("#files_grid").jqGrid('navGrid','#file_grid_pager', {
		edit: false,		
		add: false,
		del: false,
		view: false,
		search: true,
		searchtext: '<?php echo str_replace('\'', '\\\'', __('BHN_SEARCH', 'blue-hat-cdn')); ?>',
		refreshtext: '<?php echo str_replace('\'', '\\\'', __('BHN_REFRESH', 'blue-hat-cdn')); ?>'
	}, {}, {}, {}, {
		closeAfterSearch: true,
		closeAfterReset: true,
		multipleSearch: false, 
		overlay: false,
		Reset: '<?php echo str_replace('\'', '\\\'', __('BHN_RESET_SEARCH', 'blue-hat-cdn')); ?>',
		afterRedraw: function (p) { 
            jQuery("select.selectopts").css('display', 'none');
			
			jQuery('#fbox_files_grid input[type=text]').keydown( function( e ) {
				if (e.which == 13) {
					jQuery("#fbox_files_grid input[type=text]").blur();
					jQuery("#fbox_files_grid_search").click();
					jQuery("#fbox_files_grid input[type=text]").focus();
				}
			});
        }
	}, {closeOnEscape:true});
	
	jQuery("#exclude_files").jqGrid({
		datatype: "local",
		height: 90,
		colNames:['<?php echo __('BHN_FILE_FOLDER_PATH_PATTERN', 'blue-hat-cdn'); ?>'],
		colModel:[
			{name:'name', index:'name', width:320}
		],
		caption: "<?php echo __('BHN_EXCLUDE_FILES', 'blue-hat-cdn'); ?>",
		cmTemplate: { title: false }
	});
	
	BHN.excludeFilePathPatternList = '<?php echo $settingObj->get('exclude_files', 'tmp/,logs/,cache/'); ?>';
	BHN.refreshExcludeFileGrid();
});
</script>